

global M
global K

t = 0:0.1:0.9;
A = 1e4;

OMEGA = 0:0.01:30;

for i=1:length(OMEGA),
    w = 2*pi*OMEGA(i);
    H = inv(-(w^2)*M+K);
    
    H11(i)  = H(1,1);
    H21(i)  = H(4,1);
    H31(i)  = H(7,1);
    H41(i)  = H(10,1);
    H51(i)  = H(13,1);
    H61(i)  = H(16,1);
    H71(i)  = H(19,1);
    H81(i)  = H(22,1);
    H91(i)  = H(25,1);
    H101(i) = H(28,1);
    H111(i) = H(31,1);
    H121(i) = H(34,1);
    H131(i) = H(37,1);
    H141(i) = H(40,1);
    H151(i) = H(43,1);
    H161(i) = H(46,1);
end

yy = -1:0.2:1;
zz1 = sqrt(1 - yy.^2);
zz2 = -zz1;
yy2 = -0.7:0.2:0.7;
zz3 = sqrt(0.49 - yy2.^2);
zz4 = -zz3;

idx = [1:20:101 102:130 131:20:731 732:740 741:10:781 
       782:790 791:50:1941 1961:20:2021 2022:2040 2041:20:2161 
       2162:2190 2191:50:2941];

for n=1:length(idx),
    i = idx(n);
    
    subplot(6,1,1),
    semilogy(OMEGA,abs(H11),'b-','linewidth',2,'color',[0.5 0.5 0.5])
    hold on
    semilogy([OMEGA(i) OMEGA(i)],[1e-8 1e-1],'r-')
    hold off
    axis([0 30 1e-8 1e-2])
    ylabel('|H_{11}|')
    
    subplot(6,1,2),
    plot(OMEGA,angle(H11)*180/pi,'b-','linewidth',2,'color',[0.5 0.5 0.5])
    hold on
    plot([OMEGA(i) OMEGA(i)],[-180 180],'r-')
    hold off
    axis([0 30 -180 180])
    ylabel('f_{11}','fontname','symbol')
    
    subplot(6,1,3),
    semilogy(OMEGA,abs(H41),'b-','linewidth',2,'color',[0 0.8 0])
    hold on
    semilogy([OMEGA(i) OMEGA(i)],[1e-7 1e-1],'r-')
    hold off
    axis([0 30 1e-7 1e-1])
    ylabel('|H_{41}|')
    
    subplot(6,1,4),
    plot(OMEGA,angle(H41)*180/pi,'b-','linewidth',2,'color',[0 0.8 0])
    hold on
    plot([OMEGA(i) OMEGA(i)],[-180 180],'r-')
    hold off
    axis([0 30 -180 180])
    ylabel('f_{41}','fontname','symbol')
    
    for j=1:10,
        z1  = A*abs(H11(i))*sin(2*pi*t(j)-angle(H11(i)));
        z2  = A*abs(H21(i))*sin(2*pi*t(j)-angle(H21(i)));
        z3  = A*abs(H31(i))*sin(2*pi*t(j)-angle(H31(i)));
        z4  = A*abs(H41(i))*sin(2*pi*t(j)-angle(H41(i)));
        z5  = A*abs(H51(i))*sin(2*pi*t(j)-angle(H51(i)));
        z6  = A*abs(H61(i))*sin(2*pi*t(j)-angle(H61(i)));
        z7  = A*abs(H71(i))*sin(2*pi*t(j)-angle(H71(i)));
        z8  = A*abs(H81(i))*sin(2*pi*t(j)-angle(H81(i)));
        z9  = A*abs(H91(i))*sin(2*pi*t(j)-angle(H91(i)));
        z10 = A*abs(H101(i))*sin(2*pi*t(j)-angle(H101(i)));
        z11 = A*abs(H111(i))*sin(2*pi*t(j)-angle(H111(i)));
        z12 = A*abs(H121(i))*sin(2*pi*t(j)-angle(H121(i)));
        z13 = A*abs(H131(i))*sin(2*pi*t(j)-angle(H131(i)));
        z14 = A*abs(H141(i))*sin(2*pi*t(j)-angle(H141(i)));
        z15 = A*abs(H151(i))*sin(2*pi*t(j)-angle(H151(i)));
        z16 = A*abs(H161(i))*sin(2*pi*t(j)-angle(H161(i)));
        f = 1.5*sin(2*pi*t(j));
        
        subplot(6,1,[5 6]),
        plot3([5 2],[0 12],[0 0],'k-')
        hold on
        plot3([3.33 1.33],[0 12],[0 0],'k-')
        plot3([1.67 0.67],[0 12],[0 0],'k-')
        plot3([0 0],[0 12],[0 0],'k-')

        plot3([0 5],[0 0],[0 0],'k-')
        plot3([0 4.25],[3 3],[0 0],'k-')
        plot3([0 3.5],[6 6],[0 0],'k-')
        plot3([0 2.75],[9 9],[0 0],'k-')
        plot3([0 2],[12 12],[0 0],'k-')
        
        plot3([4.25 4.25],[3 3],[z1-2 z1-2+f],'r-d','markerfacecolor','r')

fill3([5 4.25 2.833 3.33 5],[0 3 3 0 0],[0 z1 z5 0 0],'b')
fill3([4.25 3.5 2.33 2.833 4.25],[3 6 6 3 3],[z1 z2 z6 z5 z1],'b')
fill3([3.5 2.75 1.833 2.33 3.5],[6 9 9 6 6],[z2 z3 z7 z6 z2],'b')
fill3([2.75 2 1.33 1.833 2.75],[9 12 12 9 9],[z3 z4 z8 z7 z3],'b')

fill3([3.33 2.833 1.4167 1.67 3.33],[0 3 3 0 0],[0 z5 z9 0 0],'b')
fill3([2.833 2.33 1.167 1.4167 2.833],[3 6 6 3 3],[z5 z6 z10 z9 z5],'b')
fill3([2.33 1.833 0.9167 1.167 2.33],[6 9 9 6 6],[z6 z7 z11 z10 z6],'b')
fill3([1.833 1.33 0.67 0.9167 1.833],[9 12 12 9 9],[z7 z8 z12 z11 z7],'b')

fill3([1.67 1.4167 0 0 1.67],[0 3 3 0 0],[0 z9 z13 0 0],'b')
fill3([1.4167 1.167 0 0 1.4167],[3 6 6 3 3],[z9 z10 z14 z13 z9],'b')
fill3([1.167 0.9167 0 0 1.167],[6 9 9 6 6],[z10 z11 z15 z14 z10],'b')
fill3([0.9167 0.67 0 0 0.9167],[9 12 12 9 9],[z11 z12 z16 z15 z11],'b')

plot3(4.25,3,z1,'g.','color',[0.5 0.5 0.5],'markersize',20)
plot3(2,12,z4,'g.','color',[0 0.8 0],'markersize',20)

        plot3(5*ones(1,11),yy+3,zz1-2+z1,'b') 
        plot3(5*ones(1,11),yy+3,zz2-2+z1,'b')
        plot3(4*ones(1,11),yy+3,zz1-2+z1,'b') 
        plot3(4*ones(1,11),yy+3,zz2-2+z1,'b')
        plot3([4 5],[2 2],[-2 -2]+z1,'b-')
        plot3([4 5],[4 4],[-2 -2]+z1,'b-')
        plot3([4 5],[3 3],[-1 -1]+z1,'b-')
        plot3([4 5],[3 3],[-3 -3]+z1,'b-')
        
        plot3(4*ones(1,8),yy2+3,zz3-2+z1,'b') 
        plot3(4*ones(1,8),yy2+3,zz4-2+z1,'b')
        plot3(3*ones(1,8),yy2+3,zz3-2+z1,'b') 
        plot3(3*ones(1,8),yy2+3,zz4-2+z1,'b')
        plot3([4 3],[2.3 2.3],[-2 -2]+z1,'b-')
        plot3([4 3],[3.7 3.7],[-2 -2]+z1,'b-')
        plot3([4 3],[3 3],[-1.3 -1.3]+z1,'b-')
        plot3([4 3],[3 3],[-2.7 -2.7]+z1,'b-')
        
        plot3([4.25 4.5],[3 3],[z1 z1-1],'b-')
        plot3([2.833 3.5],[3 3],[z5 z1-1.3],'b-')
        
        hold off
        view(125,40)
        axis([-3.5 8.5 0 12 -4 4])
        pause(0.1)
        
    end
end