clear all

global MM
global KK

mp = 20;        % massa do pneu (kg)
mc = 1200;      % massa de 1/2 carro (kg)
Ic = 500;       % momento de inrcia de Roll (kg.m2)

%Ipitch = 1900;  % momento de inrcia de Pitch (kg.m2)
%Iyaw = 2000;    % momento de inrcia de Yaw (kg.m2)

ks = 40000;     % rigidez da suspenso (N/m)
kp = 0000;     % rigidez do pneu (N/m)

ds = 100;         % amortecimento da suspenso (N/m/s)
%ds = 5000;
%ds = 10000;         

L = 0.75;       % distncia entre o CG do carro e a suspenso (m)

M = [mp 0  0  0;
     0  mp 0  0;
     0  0  mc 0;
     0  0  0  Ic];
 
D = [ ds    0   -ds    ds*L;
      0     ds  -ds   -ds*L;
     -ds   -ds  2*ds     0 ;
     ds*L -ds*L  0   2*ds*L^2];
 
K = [(ks+kp)   0    -ks    ks*L;
        0   (ks+kp) -ks   -ks*L;
       -ks    -ks   2*ks    0;
       ks*L  -ks*L   0   2*ks*L^2];
   
MM = [   M    zeros(4); 
      zeros(4)   M    ];
  
KK = [ D    K    ;
      -M zeros(4)];
  
[u,v] = eig(-KK,MM);
Lam = (diag(v))

%--- MODOS DE VIBRAR ---
%modos(1)

%--- RESPOSTA LIVRE ---
Xp0 = [0; 0; 0.1; 0];
X0 = [0; 0; 0; 0];
[T,X] = ode45('integra',0:0.01:5,[Xp0; X0]);



